#pragma once
#include "CivAssembly.h"
#include "pandaDbManager.h"

class CivConnection;

/**
   תinpݿ
*/
class PANDADBMANAGER_API CivInpHelperAbs
{
public:
	// ˮģʱ
	enum QualityType
	{
		Age, // ˮ
		Chlorine // 
	};

	explicit CivInpHelperAbs(const std::string& uri);
	virtual ~CivInpHelperAbs();

	virtual void handlePump() = 0;
	virtual void handleValve() = 0;

	// Ҫ
	virtual bool getNode(CivNode& node)=0 ;
	virtual bool getPipe(CivPipe& pipe)=0 ;
	virtual bool getTank(CivTank& tank) = 0;
	virtual bool getValve(CivValve& valve) =0;
	virtual bool getPumps(CivPumps& pump) =0;
	virtual bool getReservoirs(CivReservoirs& reservoirs) =0;
	
	virtual bool getCoordinates(CivCoordinates& coord) =0;	
	virtual bool getQuality(CivQuality& quality)=0;
	virtual bool getStatus(CivStatus& status) = 0;

	void getSnToCode(std::map<std::string, std::string>& coord);

	// Ҫغ
	void setPatternTime(std::string time); // ģʽʱ
	void convertPatterns();
	void isDelayTimeSimul(bool isDelay);

	bool getPatterns(CivPatterns& patterns) ;
	bool getCurves(CivCurves& curves) ;
	bool getDemands(CivDemands& demands) ;
	bool getSources(CivSources& sources) ;
	bool getLabels(CivLabels& labels) ;
	bool getTags(CivTags& tags) ;
	bool getMixing(CivMixing& mixing);
	bool getParameter(std::vector<CivParameter>& param);
	bool getEmitters(CivEmitters& emitter);
	void setQualityType(QualityType qualiType);
protected:
	QualityType mQualityType;
	CivConnection* mDbConn;

	bool isDelayTime; // Ƿʱģ
	int mPatternTime;  // ģʽ
	std::map<std::string,std::vector<std::string>> mPatterns; // ˮģʽ

	void handleDelayPattern(const std::string& sourceDemand, const std::string& patternID, std::string& demand, std::string& pattern);
	std::string mCondtion;

	std::vector<CivPipe::PipesTable> mPipesVec;  // 
	std::vector<CivNode::NodeTable> mNodeVec; // 뷧Ĺܶ
	std::vector<CivValve::ValveTable> mValuvesVec; // 
	std::vector<CivStatus::StatusTable> mStatusVec; // ״̬
	std::vector<CivPumps::PumpTable> mPumpTables;  // ˮ
	std::vector<CivCoordinates::CoordTable> mCoords;
};
