#include "CivProjInpDbHelper.h"
#include "CivConnection.h"
#include "CivTableFields.h"

CivProjInpDbHelper::CivProjInpDbHelper(const std::string& uri)
	:CivInpHelperAbs(uri)
{
	
}

CivProjInpDbHelper::~CivProjInpDbHelper()
{

}

void CivProjInpDbHelper::setProjCode(const std::string& projCode)
{
	mPorjCode = projCode;
}

void CivProjInpDbHelper::handlePump()
{
	// ˮӵĹܶ

}

void CivProjInpDbHelper::sortProjDeatil()
{
	// ҷ޸ĵ
	std::string detailSql = "select detail.\"code\",detail.\"ͼ\",detail.\"\",detail.\"ԭֵ\",detail.\"ֵ\"\
		 from \"\" as detail where \"\"='" + mPorjCode +"' and \"\"=1";

	if (!mDbConn->execSql(detailSql))
		return;

	std::vector<std::map<std::string, std::string>> detailVec;
	mDbConn->queryResult(detailVec);

	size_t detailVecSize = detailVec.size();

	// 
	for (int i = 0; i < detailVecSize; i++)
	{
		std::map<std::string, std::string> tempMap = detailVec[i];
		std::string layerName = tempMap.find("ͼ")->second;

		mDetailMap[layerName].push_back(tempMap);
	}
}

std::string CivProjInpDbHelper::splicingConditions(const std::string& layer)
{
	std::string condition = "\"code\" not in(select  \"code\" from \"\" \
				where \"\" = '" + mPorjCode + "' and \"ͼ\" = '"+ layer +"' and \"\"=0)";

	return condition;
}

void CivProjInpDbHelper::handleValve()
{
	// Ϣ
	sortProjDeatil();

	// ȡַͬ
	std::string baseSql = "select pipe.\"\", ('UP' || pipe.\"ʼڵ\") as \"ʼڵ\", pipe.\"ֹڵ\", \
			pipe.\"ܳ\", pipe.\"ܾ\",\
			pipe.\"Ħϵ\" ,pipe.\"ϵ\"";

	//ŵιܶ
	std::string dwPipeSql = baseSql + "from \"ܶ\" as pipe where "+splicingConditions("")+" and (pipe.\"from_layer\" ='' or pipe.\"from_layer\" ='' ) \
			union "+baseSql+" from \"ܶ\" as pipe where pipe.\"\" ='"+mPorjCode+"' and (pipe.\"from_layer\" ='' or pipe.\"from_layer\" ='' ) ";

	if (!mDbConn->execSql(dwPipeSql))
		return;

	std::vector<std::map<std::string, std::string>> upPipes;
	mDbConn->queryResult(upPipes);

	size_t total = upPipes.size();
	for (int i = 0; i < total; i++)
	{
		std::map<std::string, std::string> pipe = upPipes[i];

		CivPipe::Table pipeStruct;
		pipeStruct.ID = pipe.find("")->second;
		pipeStruct.code = pipe.find("code")->second;
		pipeStruct.Node1 = pipe.find("ʼڵ")->second;
		pipeStruct.Node2 = pipe.find("ֹڵ")->second;
		pipeStruct.Length = pipe.find("ܳ")->second;
		pipeStruct.Diameter = pipe.find("ܾ")->second;
		pipeStruct.Roughness = pipe.find("Ħϵ")->second;
		pipeStruct.Status = "Open";
		pipeStruct.MinorLoss = pipe.find("ϵ")->second;

		mPipesVec.push_back(pipeStruct);
	}

	// ŵιܶ
	std::string baseSql2 = "select pipe.\"\", pipe.\"ʼڵ\", ('DW' || pipe.\"ֹڵ\") as \"ֹڵ\", \
			pipe.\"ܳ\", pipe.\"ܾ\", \pipe.\"Ħϵ\",pipe.\"ϵ\"";

	std::string upPipeSql = baseSql2 + " from \"ܶ\" as pipe where  " +splicingConditions("")+" and  (pipe.\"to_layer\" = ''  or pipe.\"to_layer\" = '') \
			union " +baseSql2 + " from \"ܶ\" as pipe where   pipe.\"\" ='" + mPorjCode + "' and (pipe.\"to_layer\" = ''  or pipe.\"to_layer\" = '') " ;

	if (!mDbConn->execSql(upPipeSql))
		return;

	std::vector<std::map<std::string, std::string>> downPipes;
	mDbConn->queryResult(downPipes);

	size_t dtotal = downPipes.size();
	for (int i = 0; i < dtotal; i++)
	{
		std::map<std::string, std::string> pipe = downPipes[i];

		CivPipe::Table pipeStruct;
		pipeStruct.ID = pipe.find("")->second;
		pipeStruct.code = pipe.find("code")->second;
		pipeStruct.Node1 = pipe.find("ʼڵ")->second;
		pipeStruct.Node2 = pipe.find("ֹڵ")->second;
		pipeStruct.Length = pipe.find("ܳ")->second;
		pipeStruct.Diameter = pipe.find("ܾ")->second;
		pipeStruct.Roughness = pipe.find("Ħϵ")->second;
		pipeStruct.Status = "Open";
		pipeStruct.MinorLoss = pipe.find("ϵ")->second;

		mPipesVec.push_back(pipeStruct);
	}

	//  Ϣ 
	std::string startSql = "SELECT  va.\"code\",'UP' || va.\"\" AS \"\", vnode.\"߳\", vnode.\"ˮ\", vnode.\"ˮģʽ\" \
		, (va.\"\" + 1) AS \"\", (va.\"\" + 1) AS \"\", va.\"\" as \"ű\", \
		va.\"\" as \"\", ('UP' || va.\"\") as \"ʼڵ\",\
		va.\"ֱ\" as \"ֱ\", va.\"̶״̬\" as \"״̬\", va.\"\" as \"\", va.\"ˮϵ\"\
		FROM \"\" va, ( \
			SELECT node.\"\", node.\"߳\", node.\"ˮ\", node.\"ˮģʽ\", node.\"\", node.\"\", va.\"ֹڵ\" \
			FROM \"ڵ\" node, ( \
				SELECT  pipe.\"ʼڵ\", pipe.\"ֹڵ\" FROM \"ܶ\" pipe \
				WHERE pipe.\"to_layer\" = '' \
				and \"code\" not in( \
					select \"code\" from \"\" \
					where \"ͼ\" = 'ܶ' and \"\" = 0 and \"\" = '" + mPorjCode + "' \
				) \
				union \
				select pipe.\"ʼڵ\", pipe.\"ֹڵ\" FROM \"ܶ\" pipe where pipe.\"to_layer\" = '' and \"\" = '" + mPorjCode + "' \
				) va \
			WHERE node.\"\" = va.\"ʼڵ\" and node.\"code\" not in(select \"code\" from \"\" \
				where \"ͼ\" = 'ڵ' and \"\" = 0 and \"\" = '" + mPorjCode + "') \
			union \
			SELECT node.\"\", node.\"߳\", node.\"ˮ\", node.\"ˮģʽ\", node.\"\", node.\"\", va.\"ֹڵ\" \
			FROM \"ڵ\" node, ( \
				SELECT  pipe.\"ʼڵ\", pipe.\"ֹڵ\" FROM \"ܶ\" pipe \
				WHERE pipe.\"to_layer\" = '' \
				and \"code\" not in( \
					select \"code\" from \"\" \
					where \"ͼ\" = 'ܶ' and \"\" = 0 and \"\" = '" + mPorjCode + "' \
				) \
				union \
				select pipe.\"ʼڵ\", pipe.\"ֹڵ\" FROM \"ܶ\" pipe where pipe.\"to_layer\" = '' and \"\" = '" + mPorjCode + "' \
				) va \
			WHERE node.\"\" = va.\"ʼڵ\" and node.\"\" = '" + mPorjCode + "' \
			) vnode \
		WHERE vnode.\"ֹڵ\" = va.\"\" and va.\"code\" not in(select \"code\" from \"\" \
			where \"ͼ\" = '' and \"\" = 0 and \"\" = '" + mPorjCode + "') \
		union \
		SELECT  va.\"code\", 'UP' || va.\"\" AS \"\", vnode.\"߳\", vnode.\"ˮ\", vnode.\"ˮģʽ\" \
		, (va.\"\" +1) AS \"\", (va.\"\" + 1) AS \"\", va.\"\" as \"ű\", \
		va.\"\" as \"\", ('UP' || va.\"\") as \"ʼڵ\", \
		va.\"ֱ\" as \"ֱ\", va.\"̶״̬\" as \"״̬\", va.\"\" as \"\", va.\"ˮϵ\" \
		FROM \"\" va, ( \
			SELECT node.\"\", node.\"߳\", node.\"ˮ\", node.\"ˮģʽ\", node.\"\", node.\"\", va.\"ֹڵ\" \
			FROM \"ڵ\" node, ( \
				SELECT  pipe.\"ʼڵ\", pipe.\"ֹڵ\" FROM \"ܶ\" pipe \
				WHERE pipe.\"to_layer\" = '' \
				and \"code\" not in( \
					select \"code\" from \"\" \
					where \"ͼ\" = 'ܶ' and \"\" = 0 and \"\" = '" + mPorjCode + "' \
				) \
				union \
				select pipe.\"ʼڵ\", pipe.\"ֹڵ\" FROM \"ܶ\" pipe where pipe.\"to_layer\" = '' and \"\" = '" + mPorjCode + "' \
				) va \
			WHERE node.\"\" = va.\"ʼڵ\" and node.\"code\" not in(select \"code\" from \"\" \
				where \"ͼ\" = 'ڵ' and \"\" = 0 and \"\" = '" + mPorjCode + "') \
			union \
			SELECT node.\"\", node.\"߳\", node.\"ˮ\", node.\"ˮģʽ\", node.\"\", node.\"\", va.\"ֹڵ\" \
			FROM \"ڵ\" node, ( \
				SELECT  pipe.\"ʼڵ\", pipe.\"ֹڵ\" FROM \"ܶ\" pipe \
				WHERE pipe.\"to_layer\" = '' \
				and \"code\" not in( \
					select \"code\" from \"\" \
					where \"ͼ\" = 'ܶ' and \"\" = 0 and \"\" = '" + mPorjCode + "' \
				) \
				union \
				select pipe.\"ʼڵ\", pipe.\"ֹڵ\" FROM \"ܶ\" pipe where pipe.\"to_layer\" = '' and \"\" = '" + mPorjCode + "' \
				) va \
			WHERE node.\"\" = va.\"ʼڵ\" and node.\"\" = '" + mPorjCode + "' \
			) vnode \
		WHERE vnode.\"ֹڵ\" = va.\"\" and va.\"\" = '" + mPorjCode + "'";

	if (!mDbConn->execSql(startSql))
		return;

	std::vector<std::map<std::string, std::string>> valvesVec;
	mDbConn->queryResult(valvesVec);
	
	// ҳڵͼ޸ĵֵ
	std::vector<std::map<std::string, std::string>> valvesDetailVec;
	auto iter = mDetailMap.find("");
	if (iter != mDetailMap.end())
		valvesDetailVec = iter->second;


	std::map<std::string, CivValve::ValveTable> valveTableMap;
	std::map<std::string, CivPipe::PipesTable> pipeTableMap;
	size_t valvsSize = valvesVec.size();
	for (int i = 0; i < valvsSize; i++)
	{
		std::map<std::string, std::string> valveMap = valvesVec[i];

		// ڵ
		CivNode::NodeTable nodeTable;
		std::string szNo = valveMap.find("")->second;
		nodeTable.ID = szNo;
		nodeTable.Elev = valveMap.find("߳")->second;

		std::string patternID = valveMap.find("ˮģʽ")->second;
		std::string demand = valveMap.find("ˮ")->second;
		handleDelayPattern(demand, patternID, nodeTable.Demand, nodeTable.PatternId);

		mNodeVec.push_back(nodeTable);

		// ڵ
		CivCoordinates::CoordTable coordTable;
		coordTable.ID = szNo;
		coordTable.XCoord = valveMap.find("")->second;
		coordTable.YCoord = valveMap.find("")->second;

		mCoords.push_back(coordTable);

		std::string valveSn = valveMap.find("ű")->second;
		std::string valveType = valveMap.find("")->second;
		std::string valveStatus = valveMap.find("״̬")->second;
		std::string code = valveMap.find("code")->second;

		// codeƥ
		for (int i = 0; i < valvesDetailVec.size(); i++)
		{
			auto detailMap = valvesDetailVec[i];

			//code ƥ䣬һѭ
			auto codeIter = detailMap.find("code");
			if (codeIter == detailMap.end())
				continue;

			// code ԭcode, 
			if (codeIter->second == code)
				continue;

			// ޸ĶӦֵ
			std::string attri = detailMap.find("")->second;
			std::string newValue = detailMap.find("ֵ")->second;
			if (attri == "̶״̬")
			{
				valveStatus = newValue;
			}
		}

		if (valveType == "BV") // ֹطתɹܶ
		{
			CivPipe::Table pipeStruct;

			pipeStruct.ID = valveSn;
			pipeStruct.Node1 = szNo;
			pipeStruct.Length = "2";
			pipeStruct.Diameter = valveMap.find("ֱ")->second;
			pipeStruct.Roughness = std::string("130");//valveMap.find("Ħϵ")->second;
			pipeStruct.Status = (valveStatus== "") ? "CV" : "Open";
			pipeStruct.MinorLoss = "0";

			auto pter = std::make_pair(valveSn, pipeStruct);
			pipeTableMap.insert(pter);
		}
		else
		{
			// 
			CivValve::ValveTable valveTable;
			valveTable.ID = valveSn;
			valveTable.Node1 = szNo;
			valveTable.Diameter = valveMap.find("ֱ")->second;
			valveTable.Type = valveType;
			valveTable.Setting = valveMap.find("")->second;
			valveTable.MinorLoss = valveMap.find("ˮϵ")->second;

			valveTableMap.insert(std::make_pair(szNo, valveTable));

			// ״̬
			CivStatus::StatusTable statusTable;
			statusTable.ID = valveSn;
			statusTable.Setting = valveStatus;

			mStatusVec.push_back(statusTable);
		}

	}


	//--췧ֹڵ
	std::string vaEndSql = "SELECT 'DW' || va.\"\" AS \"\", vnode.\"߳\", vnode.\"ˮ\", vnode.\"ˮģʽ\"\
		, (va.\"\" - 1) AS \"\", (va.\"\" - 1) AS \"\", va.\"\" as \"ű\",\
		va.\"\" as \"\", ('DW' || va.\"\") as \"ֹڵ\"\
		FROM \"\" va, (\
			SELECT node.\"\", node.\"߳\", node.\"ˮ\", node.\"ˮģʽ\", node.\"\", node.\"\", va.\"ʼڵ\"\
			FROM \"ڵ\" node, (\
				SELECT pipe.\"\", pipe.\"ʼڵ\", pipe.\"ֹڵ\", pipe.\"ܳ\", pipe.\"ܾ\", pipe.\"Ħϵ\"\
				FROM \"ܶ\" pipe\
				WHERE pipe.\"from_layer\" = '' and pipe.\"code\"\
				not in(select \"code\" from \"\" where \"ͼ\" = 'ܶ' and \"\" = 0 and \"\" = '"+mPorjCode +"')\
				union\
				SELECT pipe.\"\", pipe.\"ʼڵ\", pipe.\"ֹڵ\", pipe.\"ܳ\", pipe.\"ܾ\", pipe.\"Ħϵ\"\
				FROM \"ܶ\" pipe\
				WHERE pipe.\"from_layer\" = '' and pipe.\"\" = '"+mPorjCode +"'\
				) va \
			WHERE node.\"\" = va.\"ֹڵ\" and node.\"code\"\
			not in(select \"code\" from \"\" where \"ͼ\" = 'ܶ' and \"\" = 0 and \"\" = '"+mPorjCode +"')\
			union\
			SELECT node.\"\", node.\"߳\", node.\"ˮ\", node.\"ˮģʽ\", node.\"\", node.\"\", va.\"ʼڵ\"\
			FROM \"ڵ\" node, (\
				SELECT pipe.\"\", pipe.\"ʼڵ\", pipe.\"ֹڵ\", pipe.\"ܳ\", pipe.\"ܾ\", pipe.\"Ħϵ\"\
				FROM \"ܶ\" pipe\
				WHERE pipe.\"from_layer\" = '' and pipe.\"code\"\
				not in(select \"code\" from \"\" where \"ͼ\" = 'ܶ' and \"\" = 0 and \"\" = '"+mPorjCode +"')\
				union\
				SELECT pipe.\"\", pipe.\"ʼڵ\", pipe.\"ֹڵ\", pipe.\"ܳ\", pipe.\"ܾ\", pipe.\"Ħϵ\"\
				FROM \"ܶ\" pipe\
				WHERE pipe.\"from_layer\" = '' and pipe.\"\" = '"+mPorjCode +"'\
				) va\
			WHERE node.\"\" = va.\"ֹڵ\" and node.\"\" = '"+mPorjCode +"'\
			) vnode\
		WHERE vnode.\"ʼڵ\" = va.\"\"\
		and va.\"code\" not in(select \"code\" from \"\" where \"ͼ\" = '' and \"\" = 0 and \"\" = '"+mPorjCode +"')\
		union\
		SELECT 'DW' || va.\"\" AS \"\", vnode.\"߳\", vnode.\"ˮ\", vnode.\"ˮģʽ\"\
		, (va.\"\" - 1) AS \"\", (va.\"\" -1) AS \"\", va.\"\" as \"ű\",\
		va.\"\" as \"\", ('DW' || va.\"\") as \"ֹڵ\"\
		FROM \"\" va, (\
			SELECT node.\"\", node.\"߳\", node.\"ˮ\", node.\"ˮģʽ\", node.\"\", node.\"\", va.\"ʼڵ\"\
			FROM \"ڵ\" node, (\
				SELECT pipe.\"\", pipe.\"ʼڵ\", pipe.\"ֹڵ\", pipe.\"ܳ\", pipe.\"ܾ\", pipe.\"Ħϵ\"\
				FROM \"ܶ\" pipe\
				WHERE pipe.\"from_layer\" = '' and pipe.\"code\"\
				not in(select \"code\" from \"\" where \"ͼ\" = 'ܶ' and \"\" = 0 and \"\" = '"+mPorjCode +"')\
				union\
				SELECT pipe.\"\", pipe.\"ʼڵ\", pipe.\"ֹڵ\", pipe.\"ܳ\", pipe.\"ܾ\", pipe.\"Ħϵ\"\
				FROM \"ܶ\" pipe\
				WHERE pipe.\"from_layer\" = '' and pipe.\"\" = '"+mPorjCode +"'\
				) va\
			WHERE node.\"\" = va.\"ֹڵ\" and node.\"code\"\
			not in(select \"code\" from \"\" where \"ͼ\" = 'ܶ' and \"\" = 0 and \"\" = '"+mPorjCode +"')\
			union\
			SELECT node.\"\", node.\"߳\", node.\"ˮ\", node.\"ˮģʽ\", node.\"\", node.\"\", va.\"ʼڵ\"\
			FROM \"ڵ\" node, (\
				SELECT pipe.\"\", pipe.\"ʼڵ\", pipe.\"ֹڵ\", pipe.\"ܳ\", pipe.\"ܾ\", pipe.\"Ħϵ\"\
				FROM \"ܶ\" pipe\
				WHERE pipe.\"from_layer\" = '' and pipe.\"code\"\
				not in(select \"code\" from \"\" where \"ͼ\" = 'ܶ' and \"\" = 0 and \"\" = '"+mPorjCode +"')\
				union\
				SELECT pipe.\"\", pipe.\"ʼڵ\", pipe.\"ֹڵ\", pipe.\"ܳ\", pipe.\"ܾ\", pipe.\"Ħϵ\"\
				FROM \"ܶ\" pipe\
				WHERE pipe.\"from_layer\" = '' and pipe.\"\" = '"+mPorjCode +"'\
				) va\
			WHERE node.\"\" = va.\"ֹڵ\" and node.\"\" = '"+mPorjCode +"'\
			) vnode\
		WHERE vnode.\"ʼڵ\" = va.\"\" and va.\"\" = '"+mPorjCode +"'";

	if (!mDbConn->execSql(vaEndSql))
		return;

	std::vector<std::map<std::string, std::string>> valvesEndVec;
	mDbConn->queryResult(valvesEndVec);

	size_t endVecSize = valvesEndVec.size();
	for (int i = 0; i < endVecSize; i++)
	{
		std::map<std::string, std::string> valveMap = valvesEndVec[i];

		// ڵ
		CivNode::NodeTable nodeTable;
		std::string szNo = valveMap.find("")->second;
		nodeTable.ID = szNo;
		nodeTable.Elev = valveMap.find("߳")->second;

		std::string patternID = valveMap.find("ˮģʽ")->second;
		std::string demand = valveMap.find("ˮ")->second;
		handleDelayPattern(demand, patternID, nodeTable.Demand, nodeTable.PatternId);

		mNodeVec.push_back(nodeTable);

		// ڵ
		CivCoordinates::CoordTable coordTable;
		coordTable.ID = szNo;
		coordTable.XCoord = valveMap.find("")->second;
		coordTable.YCoord = valveMap.find("")->second;

		mCoords.push_back(coordTable);

		std::string valveSn = valveMap.find("ű")->second;
		std::string valveType = valveMap.find("")->second;

		if (valveType == "BV") // ֹطתɹܶ
		{
			auto iter = pipeTableMap.find(valveSn);
			if (iter != pipeTableMap.end())
			{
				pipeTableMap[valveSn].Node2 = szNo;
				mPipesVec.push_back(iter->second);
			}
		}
		else
		{
			// 
			auto iter = valveTableMap.find(valveSn);
			if (iter != valveTableMap.end())
			{
				valveTableMap[valveSn].Node2 = szNo;
				mValuvesVec.push_back(iter->second);
			}
		}
	}
}

bool CivProjInpDbHelper::getNode(CivNode& node)
{
	// ңڵ
	JunctionTable nodeTableFields;

	std::string sql = "select  \"code\",  \"\", \"߳\", \"ˮ\", \"ˮģʽ\", \"\",\"\" \
							from  \"ڵ\"   where\
							\"code\" not in(select det.\"code\" from \"\" as det where det.\"\" = '"+mPorjCode+"' and \"ͼ\" = 'ڵ' and \"\"=0)\
							union   select   \"code\",  \"\", \"߳\", \"ˮ\", \"ˮģʽ\", \"\",\"\" \
							from   \"ڵ\"  where    \"\" = '"+ mPorjCode +"' ";

	if (!mDbConn->execSql(sql))
		return false;

	std::vector<std::map<std::string, std::string>> resultVector;
	mDbConn->queryResult(resultVector);

	// ҳڵͼ޸ĵֵ
	std::vector<std::map<std::string, std::string>> nodeDetailVec;
	auto iter = mDetailMap.find(PIPENODE);
	if (iter != mDetailMap.end())
		nodeDetailVec = iter->second;

	// ༭װ
	size_t total = resultVector.size();
	for (int i = 0; i < total; i++)
	{
		std::map<std::string, std::string> map = resultVector[i];
		CivNode::NodeTable nodeTable;

		std::string code = map.find(nodeTableFields.code)->second;
		std::string elev = map.find(nodeTableFields.elev)->second;
		std::string patternID = map.find(nodeTableFields.demandPattern)->second;
		std::string demand = map.find(nodeTableFields.baseDemand)->second;

		// codeƥ
		for (int i = 0; i < nodeDetailVec.size(); i++)
		{
			auto detailMap = nodeDetailVec[i];

			//code ƥ䣬һѭ
			auto codeIter = detailMap.find(nodeTableFields.code);
			if (codeIter == detailMap.end())
				continue;

			// code ԭcode, 
			if (codeIter->second  == code)
				continue;

			// ޸ĶӦֵ
			std::string attri = detailMap.find("")->second;
			std::string newValue = detailMap.find("ֵ")->second;
			if (attri == nodeTableFields.elev)
			{
				elev = newValue;
			}
			else if (attri == nodeTableFields.demandPattern)
			{
				patternID = newValue;
			}
			else if (attri == nodeTableFields.baseDemand)
			{
				demand = newValue;
			}

		}

		nodeTable.ID = map.find("")->second;
		nodeTable.Elev = elev;
		handleDelayPattern(demand, patternID, nodeTable.Demand, nodeTable.PatternId);

		node.addItem(nodeTable);
	}

	// ӴķŲĽڵ
	size_t size = mNodeVec.size();
	for (int i = 0; i < size; i++)
	{
		node.addItem(mNodeVec[i]);
	}

	return true;
}

bool CivProjInpDbHelper::getPipe(CivPipe& pipes)
{
	PipeTable pipeTable;

	std::string sql = "select  \"code\",\"\",\"ʼڵ\",\"ֹڵ\",\"ܳ\",\"ܾ\",\"Ħϵ\",\"ϵ\",\"ʼ״̬\"\
							 from \"ܶ\" \
							where \"from_layer\" not in('','','ˮ','ˮ') \
							and \"to_layer\" not in('','','ˮ','ˮ') \
							and \"code\" not in(select det.\"code\" from \"\" as det where det.\"\" = '"+mPorjCode+"' and \"ͼ\"='ܶ')\
							union select \
							\"code\",\"\",\"ʼڵ\",\"ֹڵ\",\"ܳ\",\"ܾ\",\"Ħϵ\",\"ϵ\",\"ʼ״̬\" from \"ܶ\" where \
							\"\" = '"+mPorjCode+"'";

	if (!mDbConn->execSql(sql))
		return false;

	std::vector<std::map<std::string, std::string>> resultVector;
	mDbConn->queryResult(resultVector);

	// ҳܶͼ޸ĵֵ
	std::vector<std::map<std::string, std::string>> lineDetailVec;
	auto iter = mDetailMap.find(PIPELINE);
	if (iter != mDetailMap.end())
		lineDetailVec = iter->second;

	size_t total = resultVector.size();
	for (int i = 0; i < total; i++)
	{
		CivPipe::PipesTable pipe;

		std::map<std::string, std::string> map = resultVector[i];

		std::string code = map.find("code")->second;
		pipe.ID = map.find(pipeTable.snNo)->second;
		pipe.Node1 = map.find(pipeTable.startPoint)->second;
		pipe.Node2 = map.find(pipeTable.endPoint)->second;
		pipe.Status = map.find(pipeTable.status)->second;

		std::string Length = map.find(pipeTable.length)->second;
		std::string Diameter = map.find(pipeTable.diameter)->second;
		std::string Roughness = map.find(pipeTable.friction)->second;
		std::string MinorLoss = map.find(pipeTable.localLoss)->second;

		for (int i = 0; i < lineDetailVec.size(); i++)
		{
			std::map<std::string, std::string>  detailMap = lineDetailVec[i];

			//code ƥ䣬һѭ
			auto codeIter = detailMap.find("code");
			if (codeIter == detailMap.end())
				continue;

			// code ԭcode, 
			if (codeIter->second != code)
				continue;

			// ޸ĶӦֵ
			std::string attri = detailMap.find("")->second;
			if (attri == pipeTable.length)
			{
				Length = detailMap.find("ֵ")->second;
			}
			else if (attri == pipeTable.diameter)
			{
				Diameter = detailMap.find("ֵ")->second;
			}
			else if (attri == pipeTable.friction)
			{
				Roughness = detailMap.find("ֵ")->second;
			}
			else if (attri == pipeTable.localLoss)
			{
				MinorLoss = detailMap.find("ֵ")->second;
			}
		}

		pipe.Length = Length;
		pipe.Diameter = Diameter;
		pipe.Roughness = Roughness;
		pipe.MinorLoss = MinorLoss;
		
		pipes.addItem(pipe);
	}
	// ϴźˮòܶ
	for (int i = 0; i < mPipesVec.size(); i++)
	{
		pipes.addItem(mPipesVec[i]);
	}
	return true;
}

bool CivProjInpDbHelper::getTank(CivTank& tanks)
{
	TankTable tankTable;
	std::string sql = "select \"code\",\"\",\"߳\",\"ʼˮλ\",\"ˮλ\",\"ˮλ\",\"ֱ\",\
		\"Сݻ\",\"ݻ\" from \"ˮ\"\
		where \"code\" not in(select det.\"code\" from \"\" as det\
		 where det.\"\" = '"+mPorjCode+"' and det.\"ͼ\" = 'ˮ') \
		union select  \"code\",\"\",\"߳\",\"ʼˮλ\",\"ˮλ\",\
			\"ˮλ\",\"ֱ\", \"Сݻ\",\"ݻ\" from \"ˮ\"\
		where \"\"='"+mPorjCode+"'";

	if (!mDbConn->execSql(sql))
		return false;

	std::vector<std::map<std::string, std::string>> resultVector;
	mDbConn->queryResult(resultVector);

	// ҳڵͼ޸ĵֵ
	std::vector<std::map<std::string, std::string>> tankDetailVec;
	auto iter = mDetailMap.find(PIPENODE);
	if (iter != mDetailMap.end())
		tankDetailVec = iter->second;

	size_t total = resultVector.size();
	for (int i = 0; i < total; i++)
	{
		CivTank::TankTable tank;
		std::map<std::string, std::string>map = resultVector[i];

		std::string code = map.find("code")->second;

		tank.ID = map.find(tankTable.sn)->second;
		std::string Elev = map.find(tankTable.elev)->second;
		std::string InitLevel = map.find(tankTable.initLevel)->second;
		std::string MinLevel = map.find(tankTable.minLevel)->second;
		std::string MaxLevel = map.find(tankTable.maxLevel)->second;
		std::string Diameter = map.find(tankTable.diametor)->second;
		std::string MinVol = map.find(tankTable.minVolume)->second;
		std::string VolCurve = map.find(tankTable.volumeCurve)->second;

		// codeƥ
		for (int i = 0; i < tankDetailVec.size(); i++)
		{
			auto detailMap = tankDetailVec[i];

			//code ƥ䣬һѭ
			auto codeIter = detailMap.find("code");
			if (codeIter == detailMap.end())
				continue;

			// code ԭcode, 
			if (codeIter->second == code)
				continue;

			// ޸ĶӦֵ
			std::string attri = detailMap.find("")->second;
			std::string newValue = detailMap.find("ֵ")->second;

			if (attri == tankTable.elev)
			{
				Elev = newValue;
			}
			else if (attri == tankTable.initLevel)
			{
				InitLevel = newValue;
			}
			else if (attri == tankTable.minLevel)
			{
				MinLevel = newValue;
			}
			else if (attri == tankTable.maxLevel)
			{
				MaxLevel = newValue;
			}
			else if (attri == tankTable.diametor)
			{
				Diameter = newValue;
			}
			else if (attri == tankTable.minVolume)
			{
				MinVol = newValue;
			}
			else if (attri == tankTable.volumeCurve)
			{
				VolCurve = newValue;
			}
		}

		tank.Elev = Elev;
		tank.InitLevel = InitLevel;
		tank.MinLevel = MinLevel;
		tank.MaxLevel = MaxLevel;
		tank.Diameter = Diameter;
		tank.MinVol = MinVol;
		tank.VolCurve = VolCurve;

		tanks.addItem(tank);
	}

	return true;
}

bool CivProjInpDbHelper::getValve(CivValve& valves)
{
	/*ValveTable vaveTable;
	std::vector<std::string> fields;

	fields.push_back(vaveTable.sn);
	fields.push_back(vaveTable.startPoint);
	fields.push_back(vaveTable.endPoint);
	fields.push_back(vaveTable.length);
	fields.push_back(vaveTable.type);
	fields.push_back(vaveTable.setting);
	fields.push_back(vaveTable.lossCoeff);

	std::vector<std::map<std::string, std::string>> resultVector;
	mDbConn->query(VALVE, fields, resultVector);
	mDbConn->query(PROJ_VALVE, fields, resultVector, mCondition);

	size_t totals = resultVector.size();
	for (int i = 0; i < totals; i++)
	{
		CivValve::ValveTable vave;
		std::map<std::string, std::string> map = resultVector[i];

		vave.ID = map.find(vaveTable.sn)->second;
		vave.Node1 = map.find(vaveTable.startPoint)->second;
		vave.Node2 = map.find(vaveTable.endPoint)->second;
		vave.Diameter = map.find(vaveTable.length)->second;
		vave.Type = map.find(vaveTable.type)->second;
		vave.Setting = map.find(vaveTable.setting)->second;
		vave.MinorLoss = map.find(vaveTable.lossCoeff)->second;

		valves.addItem(vave);
	}*/
	for (int i = 0; i < mValuvesVec.size(); i++)
	{
		valves.addItem(mValuvesVec[i]);
	}
	return true;
}

bool CivProjInpDbHelper::getPumps(CivPumps& pumps)
{
	PumpTable pmTable;

	std::vector<std::string> fields;	
	fields.push_back(pmTable.sn);
	fields.push_back(pmTable.startPoint);
	fields.push_back(pmTable.endPoint);
	fields.push_back(pmTable.headCurve);
	fields.push_back(pmTable.power);
	
	std::vector<std::map<std::string, std::string>> resultVector;
	std::string condition1 = splicingConditions(PUMP);
	mDbConn->query(PUMP, fields, resultVector, condition1);

	std::string condition2 = " \"\" = '" + mPorjCode + "'";
	mDbConn->query(PROJ_PUMP, fields, resultVector, condition2);

	size_t totals = resultVector.size();
	for (int i = 0; i < totals; i++)
	{
		CivPumps::PumpTable pump;
		std::map<std::string, std::string> map = resultVector[i];

		pump.ID = map.find(pmTable.sn)->second;
		pump.Node1 = map.find(pmTable.startPoint)->second;
		pump.Node2 = map.find(pmTable.endPoint)->second;
		std::string param = "Head 1";

		std::string curve = map.find(pmTable.headCurve)->second;
		if (curve != "")
			param = "head " + curve;

		std::string power = map.find(pmTable.power)->second;
		if (power != "")
			param.append(" power " + power);

		pump.Parameters = param;
		pumps.addItem(pump);
	}
	return true;
}

bool CivProjInpDbHelper::getReservoirs(CivReservoirs& reservoirs)
{
	ResourcesTable restemTable;

	std::string sql = "select \"code\",\"\",\"ˮͷ\",\"ˮͷģʽ\" from \"ˮ\" \
							where code not in(select \"code\" from \"\" \
							where \"\"='"+mPorjCode+"' and \"ͼ\"='ˮ' and \"\" =0) \
							union select  \"code\",\"\",\"ˮͷ\",\"ˮͷģʽ\" from \"ˮ\" where \"\" = '"+mPorjCode+"'";

	std::vector<std::map<std::string, std::string>> resultVector;

	if (!mDbConn->execSql(sql))
		return false;

	mDbConn->queryResult(resultVector);

	// ҳڵͼ޸ĵֵ
	std::vector<std::map<std::string, std::string>> resourceDetailVec;
	auto iter = mDetailMap.find(PIPENODE);
	if (iter != mDetailMap.end())
		resourceDetailVec = iter->second;

	size_t totals = resultVector.size();
	for (int i = 0; i < totals; i++)
	{
		CivReservoirs::ReservoirsTable resTable;
		std::map<std::string, std::string> map = resultVector[i];

		std::string code = map.find("code")->second;
		std::string totalHead = map.find(restemTable.totalHead)->second;
		std::string Pattern = map.find(restemTable.headPattern)->second;

		for (int i = 0; i < resourceDetailVec.size(); i++)
		{
			std::map<std::string, std::string> detailMap = resourceDetailVec[i];


			//code ƥ䣬һѭ
			auto codeIter = detailMap.find("code");
			if (codeIter == detailMap.end())
				continue;

			// code ԭcode, 
			if (codeIter->second != code)
				continue;

			// ޸ĶӦֵ
			std::string attri = detailMap.find("")->second;
			std::string newValue = detailMap.find("ֵ")->second;
			if (attri == restemTable.totalHead)
			{
				totalHead = newValue;
			}
			else if (attri == restemTable.headPattern)
			{
				Pattern = newValue;
			}
		}
		resTable.ID = map.find(restemTable.sn)->second;
		resTable.Head = totalHead;
		resTable.Pattern = Pattern;

		reservoirs.addItem(resTable);
	}
	return true;
}

bool CivProjInpDbHelper::getCoordinates(CivCoordinates& coord)
{
	JunctionTable nodeTable;

	std::vector<std::string> fields;

	fields.push_back(nodeTable.sn);
	fields.push_back(nodeTable.xCoord);
	fields.push_back(nodeTable.yCoord);

	std::vector<std::map<std::string, std::string>> resultVector;


	std::string condition1 = splicingConditions(PIPENODE);
	mDbConn->query(PIPENODE, fields, resultVector, condition1);

	std::string condition2 = splicingConditions(TANK);
	mDbConn->query(TANK, fields, resultVector,condition2);

	std::string condition3 = splicingConditions(RESIVOIR);
	mDbConn->query(RESIVOIR, fields, resultVector, condition3);

	std::string condition = " \"\" = '"+mPorjCode+"'";
	mDbConn->query(PROJ_PIPENODE, fields, resultVector, condition);
	mDbConn->query(PROJ_TANK, fields, resultVector, condition);
	mDbConn->query(PROJ_RESIVOIR, fields, resultVector, condition);
	
	size_t totals = resultVector.size();
	for (int i = 0; i < totals; i++)
	{
		CivCoordinates::CoordTable coordTable;
		std::map<std::string, std::string> map = resultVector[i];

		coordTable.ID = map.find(fields[0])->second;
		coordTable.XCoord = map.find(fields[1])->second;
		coordTable.YCoord = map.find(fields[2])->second;

		coord.addItem(coordTable);
	}

	// 
	for (int i = 0; i < mCoords.size(); i++)
	{
		coord.addItem(mCoords[i]);
	}
	return true;
}

bool CivProjInpDbHelper::getQuality(CivQuality& quality)
{
	JunctionTable nodeTable;

	std::vector<std::string> fields; 

	fields.push_back(nodeTable.sn);
	fields.push_back(nodeTable.initQuality);
	
	std::vector<std::map<std::string, std::string>> resultVector;
	mDbConn->query(PIPENODE, fields, resultVector);
	mDbConn->query(RESIVOIR, fields, resultVector);
	mDbConn->query(PROJ_PIPENODE, fields, resultVector, mCondition);
	mDbConn->query(PROJ_RESIVOIR, fields, resultVector, mCondition);
	
	size_t totals = resultVector.size();
	for (int i = 0; i < totals; i++)
	{
		CivQuality::QualityTable quliTable;

		std::map<std::string, std::string> map = resultVector[i];
		quliTable.ID = map.find(fields[0])->second;
		quliTable.InitQuality = map.find(fields[1])->second;;

		quality.addItem(quliTable);
	}

	return true;
}

bool CivProjInpDbHelper::getStatus(CivStatus& status)
{
	// ״̬
	for (int i = 0; i < mStatusVec.size(); i++)
	{
		status.addItem(mStatusVec[i]);
	}
	return true;
}

std::string CivProjInpDbHelper::genSql(const std::string& table)
{
	return "";
}